// Test.cpp: implementation of the CTest class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Serial758UI.h"
#include "Test.h"
#include "GlobalVar.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


extern CSerialCommTestDlg* m_pSerialCommTestDlg;

extern TESTSTRUCT m_ParTest[MAXPORTS];

extern TRANSFERSTRUCT m_TransferDataDlg[MAXPORTS];

extern ERRCHECKSTRUCT m_structErrChecking[MAXPORTS];

 
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTest::CTest()
{
	//initialize all the data members
	
	m_nRxIndex=m_nTxIndex=0;	
}

CTest::~CTest()
{

}


void CTest::OnRun(int nIndex)
{
	//this is a common function called when the user presses any of the 8 Run buttons from
	//port1  to  port8. Here if test on time is selected ,the timer is started and also the
	//port is purged . This is a common program for all the read threads and each read thread
	//creates a separate object of CTest class and a copy of this member function is given
	//to each thread.
	
	
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	
	
	CString strHr,strMin;
	char cPacCount[20];
	char cErrCount[20];
	//int nHr,nMin;
	m_nTxIndex=nIndex;//if the user has pressed RUN of first port, then nIndex will be 0
	
	time_t ltime;
	time(&ltime);//get the current time
	if(m_pSerialCommTestDlg != NULL)
	{
		m_ParTest[m_nTxIndex].bTestStop=FALSE;//reset to zero
		m_ParTest[m_nTxIndex].nErrCount=0;//reset to zero
		m_ParTest[m_nTxIndex].nPacCount=0;//reset to zero
		//m_ParTest[m_nTxIndex].nLineCount=0;//reset to zero
		
		itoa(m_ParTest[m_nTxIndex].nPacCount,cPacCount,10);
		
		itoa(m_ParTest[m_nTxIndex].nErrCount,cErrCount,10);
		
		switch(m_nTxIndex)
		{
		case 0:{			
			//if(m_pSerialCommTestDlg->m_radioStopTime1.GetCheck())
			//{
				//get the time the test has to end
				m_pSerialCommTestDlg->m_editPacCount1.SetWindowText(cPacCount);
				//m_pSerialCommTestDlg->m_editHrTime1.GetWindowText(strHr);
				//m_pSerialCommTestDlg->m_editMinTime1.GetWindowText(strMin);
				//nHr=atoi(strHr);
				//nMin=atoi(strMin);
				//m_ParTest[0].nTotalTestTime=ltime+nHr*60*60+nMin*60;//convert the test time into seconds
			//}
			
			m_pSerialCommTestDlg->m_buttonRun1.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_buttonTransfer1.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_checkLoopTest1.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_radioForever1.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_radioStopTime1.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_checkDisONOFF1.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_buttonStop1.EnableWindow(TRUE);	
			
			m_pSerialCommTestDlg->m_editTx1.SetWindowText("");
			m_pSerialCommTestDlg->m_editRx1.SetWindowText("");
			PurgeComm(pApp->m_structPort.hPortHandle[0],PURGE_RXCLEAR);//clear the extra bytes
			if (m_pSerialCommTestDlg->m_checkLoopTest1.GetCheck())
			{
				m_pSerialCommTestDlg->OnLooptest1();
			}
			
			break;
			   }
			
		case 1:{
			//if(m_pSerialCommTestDlg->m_radioStopTime2.GetCheck())
			//{
				//get the time the test has to end
				m_pSerialCommTestDlg->m_editPacCount2.SetWindowText(cPacCount);
				//m_pSerialCommTestDlg->m_editHrTime2.GetWindowText(strHr);
				//m_pSerialCommTestDlg->m_editMinTime2.GetWindowText(strMin);
			//	nHr=atoi(strHr);
			//	nMin=atoi(strMin);
			//	m_ParTest[1].nTotalTestTime=ltime+nHr*60*60+nMin*60;//convert the test time into seconds
			//}
			
			m_pSerialCommTestDlg->m_buttonRun2.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_buttonTransfer2.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_checkLoopTest2.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_radioForever2.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_radioStopTime2.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_checkDisONOFF2.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_buttonStop2.EnableWindow(TRUE);		
			
			m_pSerialCommTestDlg->m_editTx2.SetWindowText("");
			m_pSerialCommTestDlg->m_editRx2.SetWindowText("");
			PurgeComm(pApp->m_structPort.hPortHandle[1],PURGE_RXCLEAR);//clear the extra bytes
			if (m_pSerialCommTestDlg->m_checkLoopTest2.GetCheck())
			{
				m_pSerialCommTestDlg->OnLooptest2();
			}
			
			break;
			   }
			
		case 2:{
			//if(m_pSerialCommTestDlg->m_radioStopTime3.GetCheck())
			//{
				//get the time the test has to end
				m_pSerialCommTestDlg->m_editPacCount3.SetWindowText(cPacCount);
			//	m_pSerialCommTestDlg->m_editHrTime3.GetWindowText(strHr);
				//m_pSerialCommTestDlg->m_editMinTime3.GetWindowText(strMin);
				//nHr=atoi(strHr);
				//nMin=atoi(strMin);
				//m_ParTest[2].nTotalTestTime=ltime+nHr*60*60+nMin*60;//convert the test time into seconds
			//}
			
			m_pSerialCommTestDlg->m_buttonRun3.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_buttonTransfer3.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_checkLoopTest3.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_radioForever3.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_radioStopTime3.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_checkDisONOFF3.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_buttonStop3.EnableWindow(TRUE);
			
			m_pSerialCommTestDlg->m_editTx3.SetWindowText("");
			m_pSerialCommTestDlg->m_editRx3.SetWindowText("");
			PurgeComm(pApp->m_structPort.hPortHandle[2],PURGE_RXCLEAR);//clear the extra bytes
			if (m_pSerialCommTestDlg->m_checkLoopTest3.GetCheck())
			{
				m_pSerialCommTestDlg->OnLooptest3();
			}
			
			break;
			   }
			
		case 3:{
			//if(m_pSerialCommTestDlg->m_radioStopTime4.GetCheck())
			//{
				//get the time the test has to end
				m_pSerialCommTestDlg->m_editPacCount4.SetWindowText(cPacCount);
				//m_pSerialCommTestDlg->m_editHrTime4.GetWindowText(strHr);
				//m_pSerialCommTestDlg->m_editMinTime4.GetWindowText(strMin);
				//nHr=atoi(strHr);
				//nMin=atoi(strMin);
				//m_ParTest[3].nTotalTestTime=ltime+nHr*60*60+nMin*60;//convert the test time into seconds
			//}
			
			m_pSerialCommTestDlg->m_buttonRun4.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_buttonTransfer4.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_checkLoopTest4.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_radioForever4.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_radioStopTime4.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_checkDisONOFF4.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_buttonStop4.EnableWindow(TRUE);
			
			m_pSerialCommTestDlg->m_editTx4.SetWindowText("");
			m_pSerialCommTestDlg->m_editRx4.SetWindowText("");
			PurgeComm(pApp->m_structPort.hPortHandle[3],PURGE_RXCLEAR);//clear the extra bytes
			if (m_pSerialCommTestDlg->m_checkLoopTest4.GetCheck())
			{
				m_pSerialCommTestDlg->OnLooptest4();
			}
			
			break;
			
			   }
		case 4:{
		//	if(m_pSerialCommTestDlg->m_radioStopTime5.GetCheck())
		//	{
				//get the time the test has to end
				m_pSerialCommTestDlg->m_editPacCount5.SetWindowText(cPacCount);
				//m_pSerialCommTestDlg->m_editHrTime5.GetWindowText(strHr);
				//m_pSerialCommTestDlg->m_editMinTime5.GetWindowText(strMin);
				//nHr=atoi(strHr);
				//nMin=atoi(strMin);
				//m_ParTest[4].nTotalTestTime=ltime+nHr*60*60+nMin*60;//convert the test time into seconds
			//}
			
			m_pSerialCommTestDlg->m_buttonRun5.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_buttonTransfer5.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_checkLoopTest5.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_radioForever5.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_radioStopTime5.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_checkDisONOFF5.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_buttonStop5.EnableWindow(TRUE);	
			
			m_pSerialCommTestDlg->m_editTx5.SetWindowText("");
			m_pSerialCommTestDlg->m_editRx5.SetWindowText("");
			PurgeComm(pApp->m_structPort.hPortHandle[4],PURGE_RXCLEAR);//clear the extra bytes
			if (m_pSerialCommTestDlg->m_checkLoopTest5.GetCheck())
			{
				m_pSerialCommTestDlg->OnLooptest5();
			}
			
			break;
			   }
		case 5:{
			//if(m_pSerialCommTestDlg->m_radioStopTime6.GetCheck())
			//{
				//get the time the test has to end
				m_pSerialCommTestDlg->m_editPacCount6.SetWindowText(cPacCount);
				/*m_pSerialCommTestDlg->m_editHrTime6.GetWindowText(strHr);
				m_pSerialCommTestDlg->m_editMinTime6.GetWindowText(strMin);
				nHr=atoi(strHr);
				nMin=atoi(strMin);
				m_ParTest[5].nTotalTestTime=ltime+nHr*60*60+nMin*60;//convert the test time into seconds
			}*/
			
			m_pSerialCommTestDlg->m_buttonRun6.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_buttonTransfer6.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_checkLoopTest6.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_radioForever6.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_radioStopTime6.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_checkDisONOFF6.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_buttonStop6.EnableWindow(TRUE);	
			
			m_pSerialCommTestDlg->m_editTx6.SetWindowText("");
			m_pSerialCommTestDlg->m_editRx6.SetWindowText("");
			PurgeComm(pApp->m_structPort.hPortHandle[5],PURGE_RXCLEAR);//clear the extra bytes
			if (m_pSerialCommTestDlg->m_checkLoopTest6.GetCheck())
			{
				m_pSerialCommTestDlg->OnLooptest6();
			}

			break;
			   }
		case 6:{
			//if(m_pSerialCommTestDlg->m_radioStopTime7.GetCheck())
			//{
				//get the time the test has to end
				m_pSerialCommTestDlg->m_editPacCount7.SetWindowText(cPacCount);
			/*	m_pSerialCommTestDlg->m_editHrTime7.GetWindowText(strHr);
				m_pSerialCommTestDlg->m_editMinTime7.GetWindowText(strMin);
				nHr=atoi(strHr);
				nMin=atoi(strMin);
				m_ParTest[6].nTotalTestTime=ltime+nHr*60*60+nMin*60;//convert the test time into seconds
			}*/
			
			m_pSerialCommTestDlg->m_buttonRun7.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_buttonTransfer7.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_checkLoopTest7.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_radioForever7.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_radioStopTime7.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_checkDisONOFF7.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_buttonStop7.EnableWindow(TRUE);	
			
			m_pSerialCommTestDlg->m_editTx7.SetWindowText("");
			m_pSerialCommTestDlg->m_editRx7.SetWindowText("");
			PurgeComm(pApp->m_structPort.hPortHandle[7],PURGE_RXCLEAR);//clear the extra bytes
			if (m_pSerialCommTestDlg->m_checkLoopTest7.GetCheck())
			{
				m_pSerialCommTestDlg->OnLooptest7();
			}
			
			break;
			   }
		case 7:{
			//if(m_pSerialCommTestDlg->m_radioStopTime8.GetCheck())
		//	{
				//get the time the test has to end
				m_pSerialCommTestDlg->m_editPacCount8.SetWindowText(cPacCount);
			/*	m_pSerialCommTestDlg->m_editHrTime8.GetWindowText(strHr);
				m_pSerialCommTestDlg->m_editMinTime8.GetWindowText(strMin);
				nHr=atoi(strHr);
				nMin=atoi(strMin);
				m_ParTest[7].nTotalTestTime=ltime+nHr*60*60+nMin*60;//convert the test time into seconds
			}*/
			
			m_pSerialCommTestDlg->m_buttonRun8.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_buttonTransfer8.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_checkLoopTest8.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_radioForever8.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_radioStopTime8.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_checkDisONOFF8.EnableWindow(FALSE);
			m_pSerialCommTestDlg->m_buttonStop8.EnableWindow(TRUE);	
			
			m_pSerialCommTestDlg->m_editTx8.SetWindowText("");
			m_pSerialCommTestDlg->m_editRx8.SetWindowText("");
			PurgeComm(pApp->m_structPort.hPortHandle[7],PURGE_RXCLEAR);//clear the extra bytes
			if (m_pSerialCommTestDlg->m_checkLoopTest8.GetCheck())
			{
				m_pSerialCommTestDlg->OnLooptest8();
			}
			
			break;
			   }
			
		default:{
			AfxGetMainWnd()->MessageBox("DEFAULT","Error",MB_OK|MB_ICONEXCLAMATION);
			break;
				}
		}//end of switch statement
		
		OnWrite_Data(nIndex);//this function writes the data selected to the display 
		                     //and to the port
	}//end of if dialog is present
}

 void CTest::OnWrite_Data(int Index)
{
	 //this function checks the data type selected by the user and then adds the data 
	 //to the display and then writes it to the port

	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	
	bool bDisplay=TRUE;
	char cPacCount[20];

	m_structErrChecking[Index].nFileIndex=0;
	m_structErrChecking[Index].ntempReadBytes=0;//initialize 
	m_structErrChecking[Index].bInCompleteRead=FALSE;//initialize
	
	CString strTx;//string to be written in Tx edit box 	

//	for(int n=0;n<PACKETSIZE;n++)
//		pApp->m_ReadThreadParam[Index].ReadBuff[n]=' ';
	
	if(m_pSerialCommTestDlg != NULL)
	{
	switch (Index)
	{
		case 0: {	//m_pSerialCommTestDlg->m_checkTXD1.SetCheck(1);
					m_TestPort[0].SetHandle(pApp->m_structPort.hPortHandle[0]);//set the port handle
					if(m_pSerialCommTestDlg->m_checkDisONOFF1.GetCheck())
						bDisplay=TRUE;//write to display
					else
						bDisplay=FALSE;//skip writing to the display
			 		break;
				}
		case 1: {	//m_pSerialCommTestDlg->m_checkTXD2.SetCheck(1);
					m_TestPort[1].SetHandle(pApp->m_structPort.hPortHandle[1]);
					if(m_pSerialCommTestDlg->m_checkDisONOFF2.GetCheck())
						bDisplay=TRUE;
					else
						bDisplay=FALSE;
					break;
				}
		case 2: {	//m_pSerialCommTestDlg->m_checkTXD3.SetCheck(1);
					m_TestPort[2].SetHandle(pApp->m_structPort.hPortHandle[2]);
					if(m_pSerialCommTestDlg->m_checkDisONOFF3.GetCheck())
						bDisplay=TRUE;
					else
						bDisplay=FALSE;
					break;
				}
		case 3: {	//m_pSerialCommTestDlg->m_checkTXD4.SetCheck(1);
					m_TestPort[3].SetHandle(pApp->m_structPort.hPortHandle[3]);
					if(m_pSerialCommTestDlg->m_checkDisONOFF4.GetCheck())
						bDisplay=TRUE;
					else
						bDisplay=FALSE;
					break;
				}
		case 4: {	//m_pSerialCommTestDlg->m_checkTXD5.SetCheck(1);
					m_TestPort[4].SetHandle(pApp->m_structPort.hPortHandle[4]);
				
					if(m_pSerialCommTestDlg->m_checkDisONOFF5.GetCheck())
						bDisplay=TRUE;
					else
						bDisplay=FALSE;
			 		break;
				}
		case 5: {	//m_pSerialCommTestDlg->m_checkTXD6.SetCheck(1);
					m_TestPort[5].SetHandle(pApp->m_structPort.hPortHandle[5]);
					if(m_pSerialCommTestDlg->m_checkDisONOFF6.GetCheck())
						bDisplay=TRUE;
					else
						bDisplay=FALSE;
					break;
				}
		case 6: {	//m_pSerialCommTestDlg->m_checkTXD7.SetCheck(1);
					m_TestPort[6].SetHandle(pApp->m_structPort.hPortHandle[6]);
					if(m_pSerialCommTestDlg->m_checkDisONOFF7.GetCheck())
						bDisplay=TRUE;
					else
						bDisplay=FALSE;
					break;
				}
		case 7: {	//m_pSerialCommTestDlg->m_checkTXD8.SetCheck(1);
					m_TestPort[7].SetHandle(pApp->m_structPort.hPortHandle[7]);
					if(m_pSerialCommTestDlg->m_checkDisONOFF8.GetCheck())
						bDisplay=TRUE;
					else
						bDisplay=FALSE;
					break;
				}
		default:{
					AfxGetMainWnd()->MessageBox("DEFAULT","Error",MB_OK|MB_ICONEXCLAMATION);
					bDisplay=TRUE;
					break;
				 }
	}

	if(m_TransferDataDlg[Index].nAlpha)//transfer alphabets
	{
		unsigned char AlphaBuff[]="0123456789abcdefghijklmnopqrstuvwxyz.\r\n";
		int ano=sizeof(AlphaBuff)-1;
		pApp->m_WriteThreadParam[Index].nWriteBytes=ano;
		for(int q=0;q<ano;q++)
			pApp->m_WriteThreadParam[Index].WriteBuff[q]=AlphaBuff[q];

		pApp->m_WriteThreadParam[Index].WriteBuff[pApp->m_WriteThreadParam[Index].nWriteBytes]=NULL;
		m_ParTest[Index].nPacCount++;
			
		strTx=pApp->m_WriteThreadParam[Index].WriteBuff;
		if(bDisplay)//if Enable display check box is checked
			AddLineTx(strTx,Index);

		m_TestPort[Index].WritePort(pApp->m_WriteThreadParam[Index].WriteBuff,pApp->m_WriteThreadParam[Index].nWriteBytes);
		if((m_ParTest[Index].nPacCount==1) && (pApp->m_nRunCount==1))//only for the first time set this event
			SetEvent(pApp->m_structPort.hWrite);//set the event to start writing
	}
	else if(m_TransferDataDlg[Index].nQuickBrown)//transfer quickbrown
	{
		unsigned char QuickBuff[]="Quick Brown Fox Jumps Over The Lazy Dog.\r\n";
		int qno=sizeof(QuickBuff)-1;

		pApp->m_WriteThreadParam[Index].nWriteBytes=qno;
		for(int q=0;q<qno;q++)
			pApp->m_WriteThreadParam[Index].WriteBuff[q]=QuickBuff[q];

		pApp->m_WriteThreadParam[Index].WriteBuff[pApp->m_WriteThreadParam[Index].nWriteBytes]=NULL;
		m_ParTest[Index].nPacCount++;
		strTx=pApp->m_WriteThreadParam[Index].WriteBuff;
		if(bDisplay)
			AddLineTx(strTx,Index);

		m_TestPort[Index].WritePort(pApp->m_WriteThreadParam[Index].WriteBuff,pApp->m_WriteThreadParam[Index].nWriteBytes);

		if((m_ParTest[Index].nPacCount==1) && (pApp->m_nRunCount==1))//only for the first time set this event
			SetEvent(pApp->m_structPort.hWrite);//set the event to start writing

	//	DWORD dwdelay=GetTickCount()+10;//wait for 150ms for all the alphabet characters to come at one read only
		//while(GetTickCount()<dwdelay);//by the primary thread
			
	//pApp->m_WriteThreadParam[Index].bWriteNowFlag=TRUE;
		
		//if(!(WaitForSingleObject(pApp->m_WriteThreadParam[Index].hWriteDone,20000) == WAIT_OBJECT_0))
		//	AfxGetMainWnd()->MessageBox("WaitEvent Failed","Error",MB_OK|MB_ICONEXCLAMATION);
	}
	else if(m_TransferDataDlg[Index].nUserData)//transfer user specified data
	{
		CString strUserDef;
		strUserDef=m_TransferDataDlg[Index].strUser;	
		pApp->m_WriteThreadParam[Index].nWriteBytes=strUserDef.GetLength();
		for(int q=0;q<strUserDef.GetLength();q++)
			pApp->m_WriteThreadParam[Index].WriteBuff[q]=strUserDef.GetAt(q);

		//convert to string to display on to the edit box
		pApp->m_WriteThreadParam[Index].WriteBuff[pApp->m_WriteThreadParam[Index].nWriteBytes]=NULL;
		m_ParTest[Index].nPacCount++;
		strTx=pApp->m_WriteThreadParam[Index].WriteBuff;
		if(bDisplay)
			AddLineTx(strTx,Index);

		m_TestPort[Index].WritePort(pApp->m_WriteThreadParam[Index].WriteBuff,pApp->m_WriteThreadParam[Index].nWriteBytes);

		if((m_ParTest[Index].nPacCount==1) && (pApp->m_nRunCount==1))//only for the first time set this event
			SetEvent(pApp->m_structPort.hWrite);//set the event to start writing


		}
	else//send file
	{
		m_structErrChecking[Index].bFilePending=FALSE;
		m_structErrChecking[Index].nFileBytes=m_TransferDataDlg[Index].nSendFileBytes;
		
		if(m_structErrChecking[Index].nFileBytes >= (PACKETSIZE-50))//if the file size is greater than 450 or ==450
		{
			m_structErrChecking[Index].nFileBytes=m_structErrChecking[Index].nFileBytes-(PACKETSIZE-50);
			m_structErrChecking[Index].bFilePending=TRUE;//total number of bytes in a file is greater than 450
			for(int u=0;u<(PACKETSIZE-50);u++)
				pApp->m_WriteThreadParam[Index].WriteBuff[u] = m_TransferDataDlg[Index].SendFileBuff[m_structErrChecking[Index].nFileIndex++];
				
			//place the no of bytes and data to be written into the write thread structure
			//and enable write			
			pApp->m_WriteThreadParam[Index].nWriteBytes=(PACKETSIZE-50);
		}
		else//if the total number of bytes  in a given file is less than 450
		{
			m_structErrChecking[Index].bFilePending=FALSE;				
			for(int u=0;u<m_structErrChecking[Index].nFileBytes;u++)
				pApp->m_WriteThreadParam[Index].WriteBuff[u] = m_TransferDataDlg[Index].SendFileBuff[m_structErrChecking[Index].nFileIndex++];
							
			pApp->m_WriteThreadParam[Index].nWriteBytes=m_structErrChecking[Index].nFileBytes;//write the remaining bytes which are less than
																						//(PACKETSIZE-50)
		}
		pApp->m_WriteThreadParam[Index].WriteBuff[pApp->m_WriteThreadParam[Index].nWriteBytes]=NULL;
		m_ParTest[Index].nPacCount++;

		strTx=pApp->m_WriteThreadParam[Index].WriteBuff;
		if(bDisplay)
			AddLineTx(strTx,Index);
		
		m_TestPort[Index].WritePort(pApp->m_WriteThreadParam[Index].WriteBuff,pApp->m_WriteThreadParam[Index].nWriteBytes);

		if((m_ParTest[Index].nPacCount==1) && (pApp->m_nRunCount==1))//only for the first time set this event
			SetEvent(pApp->m_structPort.hWrite);//set the event to start writing


	}

	switch (Index)
	{
		case 0: { //m_pSerialCommTestDlg->m_checkTXD1.SetCheck(0);
				  itoa(m_ParTest[0].nPacCount,cPacCount,10);//convert the error count into string
				  m_pSerialCommTestDlg->m_editPacCount1.SetWindowText(cPacCount);//display the error
		
			 	  break;
				}
		case 1: { //m_pSerialCommTestDlg->m_checkTXD2.SetCheck(0);
				  itoa(m_ParTest[1].nPacCount,cPacCount,10);
				  m_pSerialCommTestDlg->m_editPacCount2.SetWindowText(cPacCount);//display the error
		
				  break;
				}
		case 2: { //m_pSerialCommTestDlg->m_checkTXD3.SetCheck(0);
				  itoa(m_ParTest[2].nPacCount,cPacCount,10);
				  m_pSerialCommTestDlg->m_editPacCount3.SetWindowText(cPacCount);//display the error
		
				  break;
				}
		case 3: { //m_pSerialCommTestDlg->m_checkTXD4.SetCheck(0);
			      itoa(m_ParTest[3].nPacCount,cPacCount,10);
				  m_pSerialCommTestDlg->m_editPacCount4.SetWindowText(cPacCount);//display the error
		
				  break;
				}
		case 4: { //m_pSerialCommTestDlg->m_checkTXD5.SetCheck(0);
			      itoa(m_ParTest[4].nPacCount,cPacCount,10);
				  m_pSerialCommTestDlg->m_editPacCount5.SetWindowText(cPacCount);//display the error
		
			 	  break;
				}
		case 5: { //m_pSerialCommTestDlg->m_checkTXD6.SetCheck(0);
			      itoa(m_ParTest[5].nPacCount,cPacCount,10);
				  m_pSerialCommTestDlg->m_editPacCount6.SetWindowText(cPacCount);//display the error
		
				  break;
				}
		case 6: { //m_pSerialCommTestDlg->m_checkTXD7.SetCheck(0);
			      itoa(m_ParTest[6].nPacCount,cPacCount,10);
				  m_pSerialCommTestDlg->m_editPacCount7.SetWindowText(cPacCount);//display the error
		
				  break;
				}
		case 7: { //m_pSerialCommTestDlg->m_checkTXD8.SetCheck(0);
			     itoa(m_ParTest[7].nPacCount,cPacCount,10);
				  m_pSerialCommTestDlg->m_editPacCount8.SetWindowText(cPacCount);//display the error
		
				  break;
				}
		default: {
				AfxGetMainWnd()->MessageBox("DEFAULT","Error",MB_OK|MB_ICONEXCLAMATION);
		
				break;
				 }
	}
	}//end of if dialog is present
	
	DWORD dwdelay=GetTickCount()+atoi(pApp->m_Delay);//wait till m_Delay
	while(GetTickCount()<dwdelay);//by the primary thread
	//AfxGetMainWnd()->UpdateWindow();
}

void CTest::On_ErrorChecking(int nNoneRx)
{
	//this is the function which is called after the port reads and adds the received
	//string on to the Rx edit box. Here the Tx and Rx data bytes are compared and if 
	//an error is encountered, then one error per packet is incremented. If the number of
	//bytes written is more than received then a IncompleteRead flag is set and until the
	//remaining bytes are received , the next packet is not sent. If it is stop on time , 
	//then if the time has lasped the write data function is not called again and Onstop 
	//function is called. If it is test for ever, then write function is called again
	//and again. If stop on error , then OnStop function is called when error is encountered.
	//In the switch statment each case represents a port. If a file is sent , then the file
	// is divided into a packet of 450 bytes each and after error checking, the next pakcet
	//is sent. After whole file is sent once, it is repeated again and again.
	
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	
	int nCorrect = 0;
	CString str;
	bool btime;
	
	char cErrCount[20];
	
	int m=0;
	/*if(nNoneRx)
	{
		for(int i=m_structErrChecking[m_nRxIndex].ntempReadBytes;i<(pApp->m_ReadThreadParam[m_nRxIndex].nReadBytes + m_structErrChecking[m_nRxIndex].ntempReadBytes);i++)
		{
			if(pApp->m_WriteThreadParam[m_nRxIndex].WriteBuff[i] != pApp->m_ReadThreadInfo[m_nRxIndex].pReadArray[m++])
			{
				m_ParTest[m_nRxIndex].nErrCount++;//increment the error count once per packet
				break;
			}
		}
		
		//if number of bytes written is not equal to that received
		if(pApp->m_WriteThreadParam[m_nRxIndex].nWriteBytes != (pApp->m_ReadThreadParam[m_nRxIndex].nReadBytes + m_structErrChecking[m_nRxIndex].ntempReadBytes))
		{
			m_structErrChecking[m_nRxIndex].ntempReadBytes=m_structErrChecking[m_nRxIndex].ntempReadBytes+pApp->m_ReadThreadParam[m_nRxIndex].nReadBytes;
			m_structErrChecking[m_nRxIndex].bInCompleteRead=TRUE;//we did not receive the full written packet
			
		}
		else
		{
			//number of bytes written and received are same
			m_structErrChecking[m_nRxIndex].ntempReadBytes=0;
			m_structErrChecking[m_nRxIndex].bInCompleteRead=FALSE;
		}
	}
	*/
	if(m_pSerialCommTestDlg != NULL)
	{
		
		switch(m_nRxIndex)
		{
		case 0:
			{
				//itoa(m_ParTest[0].nErrCount,cErrCount,10);
			//	m_pSerialCommTestDlg->m_editErrCount1.SetWindowText(cErrCount);//display the error
				if(m_pSerialCommTestDlg->m_radioStopTime1.GetCheck())//if stop on time
				{
					btime=CompareTest_CurrentTime();
					if(btime)//test time still present
					{
						if((!m_ParTest[0].bTestStop) && (pApp->m_structPort.bPortOpenFlag[0]))
						{
							if(!m_TransferDataDlg[0].nFile)
								OnWrite_Data(m_nRxIndex);//send the string again blindly if not file transfer
							else
							{
								if(!m_structErrChecking[m_nRxIndex].bFilePending)
									OnWrite_Data(m_nRxIndex);//send the string again
								else
									On_SendPendingBytes(0);
							}
						}
					}
					else
						OnStop(m_nRxIndex);
				}
				
				else if(m_pSerialCommTestDlg->m_radioForever1.GetCheck())//test forever
				{
					if((!m_ParTest[0].bTestStop) && (pApp->m_structPort.bPortOpenFlag[0]))
					{
						if(!m_TransferDataDlg[0].nFile)
							OnWrite_Data(m_nRxIndex);//send the string again
						else
						{
							if(!m_structErrChecking[m_nRxIndex].bFilePending)
								OnWrite_Data(m_nRxIndex);//send the string again
							else
								On_SendPendingBytes(0);
						}					
					}
				}
				else if(m_pSerialCommTestDlg->m_radioStopError1.GetCheck())//if stop on error 
				{
					if(!m_ParTest[0].nErrCount) 
					{
						if((!m_ParTest[0].bTestStop) && (pApp->m_structPort.bPortOpenFlag[0]))
						{
							if(!m_TransferDataDlg[0].nFile)
								OnWrite_Data(m_nRxIndex);//send the string again
							else
							{
								if(!m_structErrChecking[m_nRxIndex].bFilePending)										
									OnWrite_Data(m_nRxIndex);//send the string again
								else
									On_SendPendingBytes(0);
							}
						}
					}
					else
						OnStop(m_nRxIndex);
				}
				break;
			}//end of case 0
			
		case 1:
			{
				itoa(m_ParTest[1].nErrCount,cErrCount,10);
				if(m_pSerialCommTestDlg->m_radioStopTime2.GetCheck())//if stop on time
				{
					btime=CompareTest_CurrentTime();
					if(btime)//test time still present
					{
						if((!m_ParTest[1].bTestStop) && (pApp->m_structPort.bPortOpenFlag[1]) && (!m_structErrChecking[m_nRxIndex].bInCompleteRead))
						{
							if(!m_TransferDataDlg[1].nFile)
								OnWrite_Data(m_nRxIndex);//send the string again blindly if not file transfer
							else
							{
								if(!m_structErrChecking[m_nRxIndex].bFilePending)
									OnWrite_Data(m_nRxIndex);//send the string again
								else
									On_SendPendingBytes(1);
							}
						}					
						
					}
					else
						OnStop(m_nRxIndex);
				}
				
				else if(m_pSerialCommTestDlg->m_radioForever2.GetCheck())//test forever
				{
					if((!m_ParTest[1].bTestStop) && (pApp->m_structPort.bPortOpenFlag[1]) && (!m_structErrChecking[m_nRxIndex].bInCompleteRead))
					{
						if(!m_TransferDataDlg[1].nFile)
							OnWrite_Data(m_nRxIndex);//send the string again
						else
						{
							if(!m_structErrChecking[m_nRxIndex].bFilePending)
								OnWrite_Data(m_nRxIndex);//send the string again
							else
								On_SendPendingBytes(1);
						}					
					}
				}
				else if(m_pSerialCommTestDlg->m_radioStopError2.GetCheck())//if stop on error 
				{
					if(!m_ParTest[1].nErrCount) 
					{
						if((!m_ParTest[1].bTestStop) && (pApp->m_structPort.bPortOpenFlag[1]) && (!m_structErrChecking[m_nRxIndex].bInCompleteRead))
						{
							if(!m_TransferDataDlg[1].nFile)
								OnWrite_Data(m_nRxIndex);//send the string again
							else
							{
								if(!m_structErrChecking[m_nRxIndex].bFilePending)										
									OnWrite_Data(m_nRxIndex);//send the string again
								else
									On_SendPendingBytes(1);
							}
						}
					}
					else
						OnStop(m_nRxIndex);
				}
				break;
			}//end of case 1
			
		case 2:
			{
				itoa(m_ParTest[2].nErrCount,cErrCount,10);
				if(m_pSerialCommTestDlg->m_radioStopTime3.GetCheck())//if stop on time
				{
					btime=CompareTest_CurrentTime();
					if(btime)//test time still present
					{
						if((!m_ParTest[2].bTestStop) && (pApp->m_structPort.bPortOpenFlag[2]) && (!m_structErrChecking[m_nRxIndex].bInCompleteRead))
						{
							if(!m_TransferDataDlg[2].nFile)
								OnWrite_Data(m_nRxIndex);//send the string again blindly if not file transfer
							else
							{
								if(!m_structErrChecking[m_nRxIndex].bFilePending)
									OnWrite_Data(m_nRxIndex);//send the string again
								else
									On_SendPendingBytes(2);
							}
						}
					}
					else
						OnStop(m_nRxIndex);
				}
				
				else if(m_pSerialCommTestDlg->m_radioForever3.GetCheck())//test forever
				{
					if((!m_ParTest[2].bTestStop) && (pApp->m_structPort.bPortOpenFlag[2]) && (!m_structErrChecking[m_nRxIndex].bInCompleteRead))
					{
						if(!m_TransferDataDlg[2].nFile)
							OnWrite_Data(m_nRxIndex);//send the string again
						else
						{
							if(!m_structErrChecking[m_nRxIndex].bFilePending)
								OnWrite_Data(m_nRxIndex);//send the string again
							else
								On_SendPendingBytes(2);
						}					
					}
				}
				else if(m_pSerialCommTestDlg->m_radioStopError3.GetCheck())//if stop on error 
				{
					if(!m_ParTest[2].nErrCount) 
					{
						if((!m_ParTest[2].bTestStop) && (pApp->m_structPort.bPortOpenFlag[2]) && (!m_structErrChecking[m_nRxIndex].bInCompleteRead))
						{
							if(!m_TransferDataDlg[2].nFile)
								OnWrite_Data(m_nRxIndex);//send the string again
							else
							{
								if(!m_structErrChecking[m_nRxIndex].bFilePending)										
									OnWrite_Data(m_nRxIndex);//send the string again
								else
									On_SendPendingBytes(2);
							}
						}
					}
					else
						OnStop(m_nRxIndex);
				}
				break;
			}//end of case 2
			
		case 3:
			{
				itoa(m_ParTest[1].nErrCount,cErrCount,10);
				if(m_pSerialCommTestDlg->m_radioStopTime4.GetCheck())//if stop on time
				{
					btime=CompareTest_CurrentTime();
					if(btime)//test time still present
					{
						if((!m_ParTest[3].bTestStop) && (pApp->m_structPort.bPortOpenFlag[3]) && (!m_structErrChecking[m_nRxIndex].bInCompleteRead))
						{
							if(!m_TransferDataDlg[3].nFile)
								OnWrite_Data(m_nRxIndex);//send the string again blindly if not file transfer
							else
							{
								if(!m_structErrChecking[m_nRxIndex].bFilePending)
									OnWrite_Data(m_nRxIndex);//send the string again
								else
									On_SendPendingBytes(3);
							}
						}
					}
					else
						OnStop(m_nRxIndex);
				}
				
				else if(m_pSerialCommTestDlg->m_radioForever4.GetCheck())//test forever
				{
					if((!m_ParTest[3].bTestStop) && (pApp->m_structPort.bPortOpenFlag[3]) && (!m_structErrChecking[m_nRxIndex].bInCompleteRead))
					{
						if(!m_TransferDataDlg[3].nFile)
							OnWrite_Data(m_nRxIndex);//send the string again
						else
						{
							if(!m_structErrChecking[m_nRxIndex].bFilePending)
								OnWrite_Data(m_nRxIndex);//send the string again
							else
								On_SendPendingBytes(3);
						}					
					}
				}
				else if(m_pSerialCommTestDlg->m_radioStopError4.GetCheck())//if stop on error 
				{
					if(!m_ParTest[3].nErrCount) 
					{
						if((!m_ParTest[3].bTestStop) && (pApp->m_structPort.bPortOpenFlag[3]) && (!m_structErrChecking[m_nRxIndex].bInCompleteRead))
						{
							if(!m_TransferDataDlg[3].nFile)
								OnWrite_Data(m_nRxIndex);//send the string again
							else
							{
								if(!m_structErrChecking[m_nRxIndex].bFilePending)										
									OnWrite_Data(m_nRxIndex);//send the string again
								else
									On_SendPendingBytes(3);
							}
						}
					}
					else
						OnStop(m_nRxIndex);
				}
				break;
			}//end of case 3
			
		case 4:
			{
				itoa(m_ParTest[4].nErrCount,cErrCount,10);
				if(m_pSerialCommTestDlg->m_radioStopTime5.GetCheck())//if stop on time
				{
					btime=CompareTest_CurrentTime();
					if(btime)//test time still present
					{
						if((!m_ParTest[4].bTestStop) && (pApp->m_structPort.bPortOpenFlag[4]) && (!m_structErrChecking[m_nRxIndex].bInCompleteRead))
						{
							if(!m_TransferDataDlg[4].nFile)
								OnWrite_Data(m_nRxIndex);//send the string again blindly if not file transfer
							else
							{
								if(!m_structErrChecking[m_nRxIndex].bFilePending)
									OnWrite_Data(m_nRxIndex);//send the string again
								else
									On_SendPendingBytes(4);
							}
						}
					}
					else
						OnStop(m_nRxIndex);
				}
				
				else if(m_pSerialCommTestDlg->m_radioForever5.GetCheck())//test forever
				{
					if((!m_ParTest[4].bTestStop) && (pApp->m_structPort.bPortOpenFlag[4]) && (!m_structErrChecking[m_nRxIndex].bInCompleteRead))
					{
						if(!m_TransferDataDlg[4].nFile)
							OnWrite_Data(m_nRxIndex);//send the string again
						else
						{
							if(!m_structErrChecking[m_nRxIndex].bFilePending)
								OnWrite_Data(m_nRxIndex);//send the string again
							else
								On_SendPendingBytes(4);
						}					
					}
				}
				else if(m_pSerialCommTestDlg->m_radioStopError5.GetCheck())//if stop on error 
				{
					if(!m_ParTest[4].nErrCount) 
					{
						if((!m_ParTest[4].bTestStop) && (pApp->m_structPort.bPortOpenFlag[4]) && (!m_structErrChecking[m_nRxIndex].bInCompleteRead))
						{
							if(!m_TransferDataDlg[4].nFile)
								OnWrite_Data(m_nRxIndex);//send the string again
							else
							{
								if(!m_structErrChecking[m_nRxIndex].bFilePending)										
									OnWrite_Data(m_nRxIndex);//send the string again
								else
									On_SendPendingBytes(4);
							}
						}
					}
					else
						OnStop(m_nRxIndex);
				}
				break;
			}//end of case 4
			
		case 5:
			{
				itoa(m_ParTest[5].nErrCount,cErrCount,10);
				if(m_pSerialCommTestDlg->m_radioStopTime6.GetCheck())//if stop on time
				{
					btime=CompareTest_CurrentTime();
					if(btime)//test time still present
					{
						if((!m_ParTest[5].bTestStop) && (pApp->m_structPort.bPortOpenFlag[5]) && (!m_structErrChecking[m_nRxIndex].bInCompleteRead))
						{
							if(!m_TransferDataDlg[5].nFile)
								OnWrite_Data(m_nRxIndex);//send the string again blindly if not file transfer
							else
							{
								if(!m_structErrChecking[m_nRxIndex].bFilePending)
									OnWrite_Data(m_nRxIndex);//send the string again
								else
									On_SendPendingBytes(5);
							}
						}
					}
					else
						OnStop(m_nRxIndex);
				}
				
				else if(m_pSerialCommTestDlg->m_radioForever6.GetCheck())//test forever
				{
					if((!m_ParTest[5].bTestStop) && (pApp->m_structPort.bPortOpenFlag[5]) && (!m_structErrChecking[m_nRxIndex].bInCompleteRead))
					{
						if(!m_TransferDataDlg[5].nFile)
							OnWrite_Data(m_nRxIndex);//send the string again
						else
						{
							if(!m_structErrChecking[m_nRxIndex].bFilePending)
								OnWrite_Data(m_nRxIndex);//send the string again
							else
								On_SendPendingBytes(5);
						}					
					}
				}
				else if(m_pSerialCommTestDlg->m_radioStopError6.GetCheck())//if stop on error 
				{
					if(!m_ParTest[5].nErrCount) 
					{
						if((!m_ParTest[5].bTestStop) && (pApp->m_structPort.bPortOpenFlag[5]) && (!m_structErrChecking[m_nRxIndex].bInCompleteRead))
						{
							if(!m_TransferDataDlg[5].nFile)
								OnWrite_Data(m_nRxIndex);//send the string again
							else
							{
								if(!m_structErrChecking[m_nRxIndex].bFilePending)										
									OnWrite_Data(m_nRxIndex);//send the string again
								else
									On_SendPendingBytes(5);
							}
						}
					}
					else
						OnStop(m_nRxIndex);
				}
				break;
			}//end of case 5
			
		case 6:
			{
				itoa(m_ParTest[6].nErrCount,cErrCount,10);
				if(m_pSerialCommTestDlg->m_radioStopTime7.GetCheck())//if stop on time
				{
					btime=CompareTest_CurrentTime();
					if(btime)//test time still present
					{
						if((!m_ParTest[6].bTestStop) && (pApp->m_structPort.bPortOpenFlag[6]) && (!m_structErrChecking[m_nRxIndex].bInCompleteRead))
						{
							if(!m_TransferDataDlg[6].nFile)
								OnWrite_Data(m_nRxIndex);//send the string again blindly if not file transfer
							else
							{
								if(!m_structErrChecking[m_nRxIndex].bFilePending)
									OnWrite_Data(m_nRxIndex);//send the string again
								else
									On_SendPendingBytes(6);
							}
						}
					}
					else
						OnStop(m_nRxIndex);
				}
				
				else if(m_pSerialCommTestDlg->m_radioForever7.GetCheck())//test forever
				{
					if((!m_ParTest[6].bTestStop) && (pApp->m_structPort.bPortOpenFlag[6]) && (!m_structErrChecking[m_nRxIndex].bInCompleteRead))
					{
						if(!m_TransferDataDlg[6].nFile)
							OnWrite_Data(m_nRxIndex);//send the string again
						else
						{
							if(!m_structErrChecking[m_nRxIndex].bFilePending)
								OnWrite_Data(m_nRxIndex);//send the string again
							else
								On_SendPendingBytes(6);
						}					
					}
				}
				else if(m_pSerialCommTestDlg->m_radioStopError7.GetCheck())//if stop on error 
				{
					if(!m_ParTest[6].nErrCount) 
					{
						if((!m_ParTest[6].bTestStop) && (pApp->m_structPort.bPortOpenFlag[6]) && (!m_structErrChecking[m_nRxIndex].bInCompleteRead))
						{
							if(!m_TransferDataDlg[6].nFile)
								OnWrite_Data(m_nRxIndex);//send the string again
							else
							{
								if(!m_structErrChecking[m_nRxIndex].bFilePending)										
									OnWrite_Data(m_nRxIndex);//send the string again
								else
									On_SendPendingBytes(6);
							}
						}
					}
					else
						OnStop(m_nRxIndex);
				}
				break;
			}//end of case 6
			
		case 7:
			{
				itoa(m_ParTest[7].nErrCount,cErrCount,10);
				if(m_pSerialCommTestDlg->m_radioStopTime8.GetCheck())//if stop on time
				{
					btime=CompareTest_CurrentTime();
					if(btime)//test time still present
					{
						if((!m_ParTest[7].bTestStop) && (pApp->m_structPort.bPortOpenFlag[7]) && (!m_structErrChecking[m_nRxIndex].bInCompleteRead))
						{
							if(!m_TransferDataDlg[7].nFile)
								OnWrite_Data(m_nRxIndex);//send the string again blindly if not file transfer
							else
							{
								if(!m_structErrChecking[m_nRxIndex].bFilePending)
									OnWrite_Data(m_nRxIndex);//send the string again
								else
									On_SendPendingBytes(7);
							}
						}
					}
					else
						OnStop(m_nRxIndex);
				}
				
				else if(m_pSerialCommTestDlg->m_radioForever8.GetCheck())//test forever
				{
					if((!m_ParTest[7].bTestStop) && (pApp->m_structPort.bPortOpenFlag[7]) && (!m_structErrChecking[m_nRxIndex].bInCompleteRead))
					{
						if(!m_TransferDataDlg[7].nFile)
							OnWrite_Data(m_nRxIndex);//send the string again
						else
						{
							if(!m_structErrChecking[m_nRxIndex].bFilePending)
								OnWrite_Data(m_nRxIndex);//send the string again
							else
								On_SendPendingBytes(7);
						}					
					}
				}
				else if(m_pSerialCommTestDlg->m_radioStopError8.GetCheck())//if stop on error 
				{
					if(!m_ParTest[7].nErrCount) 
					{
						if((!m_ParTest[7].bTestStop) && (pApp->m_structPort.bPortOpenFlag[7]) && (!m_structErrChecking[m_nRxIndex].bInCompleteRead))
						{
							if(!m_TransferDataDlg[7].nFile)
								OnWrite_Data(m_nRxIndex);//send the string again
							else
							{
								if(!m_structErrChecking[m_nRxIndex].bFilePending)										
									OnWrite_Data(m_nRxIndex);//send the string again
								else
									On_SendPendingBytes(7);
							}
						}
					}
					else
						OnStop(m_nRxIndex);
				}
				break;
			}//end of case 7			
			
	}//end of switch statement
	}//end of if dialog is present*/
}

bool CTest::CompareTest_CurrentTime()
{
	//this function checks whether the test on time is completed or not.
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();

	time_t ltime;
	time(&ltime);//get the current time
	if(ltime<=m_ParTest[m_nRxIndex].nTotalTestTime)//compare the current time with total test time
		return TRUE;//if the time has not elasped
	else
		return FALSE;
	
}

void CTest::AddLineTx(CString strTx,int Index)
{
	//adds a line written to the port to the TX edit box

	if(m_pSerialCommTestDlg != NULL)
	{
	switch (Index)
	{
		case 0: { 
					m_pSerialCommTestDlg->m_editTx1.SetSel(0,-1);
					m_pSerialCommTestDlg->m_editTx1.SetSel(-1,0);
					m_pSerialCommTestDlg->m_editTx1.ReplaceSel(strTx);
			 		break;
				}
		case 1: {   m_pSerialCommTestDlg->m_editTx2.SetSel(0,-1);
					m_pSerialCommTestDlg->m_editTx2.SetSel(-1,0);
					m_pSerialCommTestDlg->m_editTx2.ReplaceSel(strTx);
					break;
				}
		case 2: {   m_pSerialCommTestDlg->m_editTx3.SetSel(0,-1);
					m_pSerialCommTestDlg->m_editTx3.SetSel(-1,0);
					m_pSerialCommTestDlg->m_editTx3.ReplaceSel(strTx);
				    break;
				}
		case 3: {	m_pSerialCommTestDlg->m_editTx4.SetSel(0,-1);
					m_pSerialCommTestDlg->m_editTx4.SetSel(-1,0);
					m_pSerialCommTestDlg->m_editTx4.ReplaceSel(strTx);
					break;
				}
		case 4: { 
					m_pSerialCommTestDlg->m_editTx5.SetSel(0,-1);
					m_pSerialCommTestDlg->m_editTx5.SetSel(-1,0);
					m_pSerialCommTestDlg->m_editTx5.ReplaceSel(strTx);
			 		break;
				}
		case 5: {   m_pSerialCommTestDlg->m_editTx6.SetSel(0,-1);
					m_pSerialCommTestDlg->m_editTx6.SetSel(-1,0);
					m_pSerialCommTestDlg->m_editTx6.ReplaceSel(strTx);
					break;
				}
		case 6: {   m_pSerialCommTestDlg->m_editTx7.SetSel(0,-1);
					m_pSerialCommTestDlg->m_editTx7.SetSel(-1,0);
					m_pSerialCommTestDlg->m_editTx7.ReplaceSel(strTx);
				    break;
				}
		case 7: {	m_pSerialCommTestDlg->m_editTx8.SetSel(0,-1);
					m_pSerialCommTestDlg->m_editTx8.SetSel(-1,0);
					m_pSerialCommTestDlg->m_editTx8.ReplaceSel(strTx);
					break;
				}
		default: {
				AfxGetMainWnd()->MessageBox("DEFAULT","Error",MB_OK|MB_ICONEXCLAMATION);
				break;
				 }
	}//end of switch
	}
}



void CTest::On_OpenPorts(int nIndex)
{
	//this function is called when user starts the test and the DTR and RTS of the 
	//ports which are opened successfully are checked

	if(m_pSerialCommTestDlg != NULL)
	{
		;
	}
}

void CTest::On_ClosePorts(int nIndex)
{
	//this function is called when the user wants to stop the test and has selected 
	//this from the  menu item. Here the TXD , RXD ,DTR and RTS check boxes are
	//unchecked

	if(m_pSerialCommTestDlg != NULL)
	{
	;
	}
}

void CTest::AddLineRx(int nIndex)
{
	//adds the string received on to the RX edit box and then calls the error
	//checking function

	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();

	m_nRxIndex=nIndex;
	

	CString strRx;

	for(int i=0;i<pApp->m_ReadThreadParam[nIndex].nReadBytes;i++)
		pApp->m_ReadThreadParam[nIndex].ReadBuff[i]=pApp->m_ReadThreadInfo[nIndex].pReadArray[i];//copy into the readthreadparam

	pApp->m_ReadThreadParam[nIndex].ReadBuff[i]=NULL;//convert into string by terminating with NULL termination

	strRx=pApp->m_ReadThreadParam[nIndex].ReadBuff;

	if(m_pSerialCommTestDlg != NULL)
	{
	switch (nIndex)
	{
	case 0: {
				if(m_pSerialCommTestDlg->m_checkDisONOFF1.GetCheck())
				{
					m_pSerialCommTestDlg->m_editRx1.SetSel(0,-1);
					m_pSerialCommTestDlg->m_editRx1.SetSel(-1,0);
					m_pSerialCommTestDlg->m_editRx1.ReplaceSel(strRx);
				}
		
					break;
			}
		case 1: {  
					if(m_pSerialCommTestDlg->m_checkDisONOFF2.GetCheck())
					{
						m_pSerialCommTestDlg->m_editRx2.SetSel(0,-1);
						m_pSerialCommTestDlg->m_editRx2.SetSel(-1,0);
						m_pSerialCommTestDlg->m_editRx2.ReplaceSel(strRx);
					}
	
			 		break;
				}
		case 2: { 
					if(m_pSerialCommTestDlg->m_checkDisONOFF3.GetCheck())
					{
						m_pSerialCommTestDlg->m_editRx3.SetSel(0,-1);
						m_pSerialCommTestDlg->m_editRx3.SetSel(-1,0);
						m_pSerialCommTestDlg->m_editRx3.ReplaceSel(strRx);
					}
	
			 		break;
				}
		case 3: {	
					if(m_pSerialCommTestDlg->m_checkDisONOFF4.GetCheck())
					{
						m_pSerialCommTestDlg->m_editRx4.SetSel(0,-1);
						m_pSerialCommTestDlg->m_editRx4.SetSel(-1,0);
						m_pSerialCommTestDlg->m_editRx4.ReplaceSel(strRx);
					}
	
			 		break;
				}
		case 4: { 
					if(m_pSerialCommTestDlg->m_checkDisONOFF5.GetCheck())
					{	
						m_pSerialCommTestDlg->m_editRx5.SetSel(0,-1);
						m_pSerialCommTestDlg->m_editRx5.SetSel(-1,0);
						m_pSerialCommTestDlg->m_editRx5.ReplaceSel(strRx);
					}
	
			 		break;
				}
		case 5: {   
					if(m_pSerialCommTestDlg->m_checkDisONOFF6.GetCheck())
					{
						m_pSerialCommTestDlg->m_editRx6.SetSel(0,-1);
						m_pSerialCommTestDlg->m_editRx6.SetSel(-1,0);
						m_pSerialCommTestDlg->m_editRx6.ReplaceSel(strRx);
					}
	
			 		break;
				}
		case 6: {  
					if(m_pSerialCommTestDlg->m_checkDisONOFF7.GetCheck())
					{
						m_pSerialCommTestDlg->m_editRx7.SetSel(0,-1);
						m_pSerialCommTestDlg->m_editRx7.SetSel(-1,0);
						m_pSerialCommTestDlg->m_editRx7.ReplaceSel(strRx);
					}
	
			 		break;
				}
		case 7: {	
					if(m_pSerialCommTestDlg->m_checkDisONOFF8.GetCheck())
					{
						m_pSerialCommTestDlg->m_editRx8.SetSel(0,-1);
						m_pSerialCommTestDlg->m_editRx8.SetSel(-1,0);
						m_pSerialCommTestDlg->m_editRx8.ReplaceSel(strRx);
					}
	
			 		break;
				}
		default: {
					AfxGetMainWnd()->MessageBox("DEFAULT","Error",MB_OK|MB_ICONEXCLAMATION);
					break;
				 }
	}//end of switch

	//error checking done only for alphabets and quick brown fox string
//	On_ErrorChecking(1);
	}//end of if dialog pointer is not NULL
}

void CTest::OnStop(int nIndex)
{
	//when the user clicks on the STOP button this function is called

	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	m_structErrChecking[nIndex].bFilePending=FALSE;
	m_structErrChecking[nIndex].ntempReadBytes=0;
	m_structErrChecking[nIndex].bInCompleteRead=FALSE;

	if(m_pSerialCommTestDlg != NULL)
	{
	switch (nIndex)
	{
	case 0:{
				m_ParTest[0].bTestStop=TRUE;//set the stop flag
				m_ParTest[0].bTestRun=FALSE;//reset the start flag
				m_ParTest[0].nErrCount=0;//reset the error count
				m_ParTest[0].nPacCount=0;//reset the error count
				m_ParTest[0].nLineCount=0;//reset the line count
		
				m_pSerialCommTestDlg->m_buttonRun1.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_buttonTransfer1.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_checkLoopTest1.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_radioForever1.EnableWindow(TRUE);
				//m_pSerialCommTestDlg->m_radioStopTime1.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_checkDisONOFF1.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_buttonStop1.EnableWindow(FALSE);

					
				break;
		   }

	case 1:{
				m_ParTest[1].bTestStop=TRUE;//set the stop flag
				m_ParTest[1].bTestRun=FALSE;//reset the start flag
				m_ParTest[1].nErrCount=0;//reset the error count
				m_ParTest[1].nPacCount=0;//reset the error count
				m_ParTest[1].nLineCount=0;//reset the line count
		
				m_pSerialCommTestDlg->m_buttonRun2.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_buttonTransfer2.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_checkLoopTest2.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_radioForever2.EnableWindow(TRUE);
				//m_pSerialCommTestDlg->m_radioStopTime2.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_checkDisONOFF2.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_buttonStop2.EnableWindow(FALSE);
			
				break;
		   }

	case 2:{
				m_ParTest[2].bTestStop=TRUE;//set the stop flag
				m_ParTest[2].bTestRun=FALSE;//reset the start flag
				m_ParTest[2].nErrCount=0;//reset the error count
				m_ParTest[2].nPacCount=0;//reset the error count
				m_ParTest[2].nLineCount=0;//reset the line count
		
				m_pSerialCommTestDlg->m_buttonRun3.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_buttonTransfer3.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_checkLoopTest3.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_radioForever3.EnableWindow(TRUE);
				//m_pSerialCommTestDlg->m_radioStopTime3.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_checkDisONOFF3.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_buttonStop3.EnableWindow(FALSE);

				break;
			}

	case 3:{
				m_ParTest[3].bTestStop=TRUE;//set the stop flag
				m_ParTest[3].bTestRun=FALSE;//reset the start flag
				m_ParTest[3].nErrCount=0;//reset the error count
				m_ParTest[3].nPacCount=0;//reset the error count
				m_ParTest[3].nLineCount=0;//reset the line count
		
				m_pSerialCommTestDlg->m_buttonRun4.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_buttonTransfer4.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_checkLoopTest4.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_radioForever4.EnableWindow(TRUE);
				//m_pSerialCommTestDlg->m_radioStopTime4.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_checkDisONOFF4.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_buttonStop4.EnableWindow(FALSE);				

				break;
		   }
	case 4:{
				m_ParTest[4].bTestStop=TRUE;//set the stop flag
				m_ParTest[4].bTestRun=FALSE;//reset the start flag
				m_ParTest[4].nErrCount=0;//reset the error count
				m_ParTest[4].nPacCount=0;//reset the error count
				m_ParTest[4].nLineCount=0;//reset the line count
		
				m_pSerialCommTestDlg->m_buttonRun5.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_buttonTransfer5.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_checkLoopTest5.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_radioForever5.EnableWindow(TRUE);
				//m_pSerialCommTestDlg->m_radioStopTime5.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_checkDisONOFF5.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_buttonStop5.EnableWindow(FALSE);

				break;
		   }

	case 5:{
				m_ParTest[5].bTestStop=TRUE;//set the stop flag
				m_ParTest[5].bTestRun=FALSE;//reset the start flag
				m_ParTest[5].nErrCount=0;//reset the error count
				m_ParTest[5].nPacCount=0;//reset the error count
				m_ParTest[5].nLineCount=0;//reset the line count
		
				m_pSerialCommTestDlg->m_buttonRun6.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_buttonTransfer6.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_checkLoopTest6.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_radioForever6.EnableWindow(TRUE);
				//m_pSerialCommTestDlg->m_radioStopTime6.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_checkDisONOFF6.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_buttonStop6.EnableWindow(FALSE);

				break;
		   }

	case 6:{
				m_ParTest[6].bTestStop=TRUE;//set the stop flag
				m_ParTest[6].bTestRun=FALSE;//reset the start flag
				m_ParTest[6].nErrCount=0;//reset the error count
				m_ParTest[6].nPacCount=0;//reset the error count
				m_ParTest[6].nLineCount=0;//reset the line count
		
				m_pSerialCommTestDlg->m_buttonRun7.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_buttonTransfer7.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_checkLoopTest7.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_radioForever7.EnableWindow(TRUE);
				//m_pSerialCommTestDlg->m_radioStopTime7.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_checkDisONOFF7.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_buttonStop7.EnableWindow(FALSE);

				break;
			}

	case 7:{
				m_ParTest[7].bTestStop=TRUE;//set the stop flag
				m_ParTest[7].bTestRun=FALSE;//reset the start flag
				m_ParTest[7].nErrCount=0;//reset the error count
				m_ParTest[7].nPacCount=0;//reset the error count
				m_ParTest[7].nLineCount=0;//reset the line count
		
				m_pSerialCommTestDlg->m_buttonRun8.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_buttonTransfer8.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_checkLoopTest8.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_radioForever8.EnableWindow(TRUE);
				//m_pSerialCommTestDlg->m_radioStopTime8.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_checkDisONOFF8.EnableWindow(TRUE);
				m_pSerialCommTestDlg->m_buttonStop8.EnableWindow(FALSE);

				break;
		   }
	default:{
			AfxGetMainWnd()->MessageBox("DEFAULT","Error",MB_OK|MB_ICONEXCLAMATION);
		break;
			}
	}//end of switch 
	}
}

void CTest::On_UpdateStatus(int nIndex, bool fCTS, bool fDSR, bool fRING, bool fRLSD)
{
	//this function checks or unchecks the check boxes of CTS, DSR, RING and RLSD

	if(m_pSerialCommTestDlg != NULL)
	{
		;
	}//end of if dialog is present

}

void CTest::On_SendPendingBytes(int Index)
{	
	//this function is called when the user has selected file transfer and the 
	//total file size is greater than 450 bytes. After the first 450 bytes are
	//transfered , this function is called by On_ErrorChecking function. Here the
	//rest of the file is sent
	
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	
	bool bDisplay=TRUE;
	char cPacCount[20];
	CString strTx;//string to be written in Tx edit box 
	
	m_structErrChecking[Index].ntempReadBytes=0;//initialize 
	m_structErrChecking[Index].bInCompleteRead=FALSE;//initialize
	
	if(m_pSerialCommTestDlg != NULL)
	{
		switch (Index)
		{
		case 0: {	
					m_TestPort[0].SetHandle(pApp->m_structPort.hPortHandle[0]);
			if(m_pSerialCommTestDlg->m_checkDisONOFF1.GetCheck())
				bDisplay=TRUE;
			else
				bDisplay=FALSE;
			break;
				}
		case 1: {	
					m_TestPort[1].SetHandle(pApp->m_structPort.hPortHandle[1]);
			if(m_pSerialCommTestDlg->m_checkDisONOFF2.GetCheck())
				bDisplay=TRUE;
			else
				bDisplay=FALSE;
			break;
				}
		case 2: {	
					m_TestPort[2].SetHandle(pApp->m_structPort.hPortHandle[2]);
			if(m_pSerialCommTestDlg->m_checkDisONOFF3.GetCheck())
				bDisplay=TRUE;
			else
				bDisplay=FALSE;
			break;
				}
		case 3: {	
					m_TestPort[3].SetHandle(pApp->m_structPort.hPortHandle[3]);
			if(m_pSerialCommTestDlg->m_checkDisONOFF4.GetCheck())
				bDisplay=TRUE;
			else
				bDisplay=FALSE;
			break;
				}
		case 4: {	 
					m_TestPort[4].SetHandle(pApp->m_structPort.hPortHandle[4]);
			if(m_pSerialCommTestDlg->m_checkDisONOFF5.GetCheck())
				bDisplay=TRUE;
			else
				bDisplay=FALSE;
			break;
				}
		case 5: {	
					m_TestPort[5].SetHandle(pApp->m_structPort.hPortHandle[5]);
			if(m_pSerialCommTestDlg->m_checkDisONOFF6.GetCheck())
				bDisplay=TRUE;
			else
				bDisplay=FALSE;
			break;
				}
		case 6: {	
					m_TestPort[6].SetHandle(pApp->m_structPort.hPortHandle[6]);
			if(m_pSerialCommTestDlg->m_checkDisONOFF7.GetCheck())
				bDisplay=TRUE;
			else
				bDisplay=FALSE;
			break;
				}
		case 7: {	
					m_TestPort[7].SetHandle(pApp->m_structPort.hPortHandle[7]);
			if(m_pSerialCommTestDlg->m_checkDisONOFF8.GetCheck())
				bDisplay=TRUE;
			else
				bDisplay=FALSE;
			break;
				}
		default:{
			AfxGetMainWnd()->MessageBox("DEFAULT","Error",MB_OK|MB_ICONEXCLAMATION);
			bDisplay=TRUE;
			break;
				}
		}//end of switch statement
		
		if(m_structErrChecking[Index].nFileBytes >= (PACKETSIZE-50))//if the file size is greater than 450 or ==450
		{
			m_structErrChecking[Index].nFileBytes=m_structErrChecking[Index].nFileBytes-(PACKETSIZE-50);
			m_structErrChecking[Index].bFilePending=TRUE;//total number of bytes in a file is greater than 450
			for(int u=0;u<(PACKETSIZE-50);u++)
				pApp->m_WriteThreadParam[Index].WriteBuff[u] = m_TransferDataDlg[Index].SendFileBuff[m_structErrChecking[Index].nFileIndex++];
			
			//place the no of bytes and data to be written into the write thread structure
			//and enable write			
			pApp->m_WriteThreadParam[Index].nWriteBytes=(PACKETSIZE-50);
		}
		else//if the total number of bytes  in a given file is less than 450
		{
			m_structErrChecking[Index].bFilePending=FALSE;				
			for(int u=0;u<m_structErrChecking[Index].nFileBytes;u++)
				pApp->m_WriteThreadParam[Index].WriteBuff[u] = m_TransferDataDlg[Index].SendFileBuff[m_structErrChecking[Index].nFileIndex++];
			
			pApp->m_WriteThreadParam[Index].nWriteBytes=m_structErrChecking[Index].nFileBytes;//write the remaining bytes which are less than
		}
		pApp->m_WriteThreadParam[Index].WriteBuff[pApp->m_WriteThreadParam[Index].nWriteBytes]=NULL;
		m_ParTest[Index].nPacCount++;
		
		strTx=pApp->m_WriteThreadParam[Index].WriteBuff;
		if(bDisplay)
			AddLineTx(strTx,Index);	
		
		m_TestPort[Index].WritePort(pApp->m_WriteThreadParam[Index].WriteBuff,pApp->m_WriteThreadParam[Index].nWriteBytes);
		
		switch (Index)
		{
		case 0: {
			itoa(m_ParTest[0].nPacCount,cPacCount,10);
			m_pSerialCommTestDlg->m_editPacCount1.SetWindowText(cPacCount);//display the error
			break;
				}
		case 1: {
			itoa(m_ParTest[1].nPacCount,cPacCount,10);
			m_pSerialCommTestDlg->m_editPacCount2.SetWindowText(cPacCount);//display the error
			break;
				}
		case 2: {
			itoa(m_ParTest[2].nPacCount,cPacCount,10);
			m_pSerialCommTestDlg->m_editPacCount3.SetWindowText(cPacCount);//display the error
			break;
				}
		case 3: {
			itoa(m_ParTest[3].nPacCount,cPacCount,10);
			m_pSerialCommTestDlg->m_editPacCount4.SetWindowText(cPacCount);//display the error
			break;
				}
		case 4: {
			itoa(m_ParTest[4].nPacCount,cPacCount,10);
			m_pSerialCommTestDlg->m_editPacCount5.SetWindowText(cPacCount);//display the error
			break;
				}
		case 5: {
			itoa(m_ParTest[5].nPacCount,cPacCount,10);
			m_pSerialCommTestDlg->m_editPacCount6.SetWindowText(cPacCount);//display the error
			break;
				}
		case 6: {
			itoa(m_ParTest[6].nPacCount,cPacCount,10);
			m_pSerialCommTestDlg->m_editPacCount7.SetWindowText(cPacCount);//display the error
			break;
				}
		case 7: {
			itoa(m_ParTest[7].nPacCount,cPacCount,10);
			m_pSerialCommTestDlg->m_editPacCount8.SetWindowText(cPacCount);//display the error
			break;
				}
		default: {
			AfxGetMainWnd()->MessageBox("DEFAULT","Error",MB_OK|MB_ICONEXCLAMATION);
			break;
				 }
		}//end of switch statement
		
		
	}//end of if dialog is present
}

void CTest::On_TestStart()
{
	//this function enables the RUN and TRANSFER buttons of all the ports and disables
	//the STOP button

	if(m_pSerialCommTestDlg != NULL)
	{
		m_pSerialCommTestDlg->m_buttonRun1.EnableWindow(TRUE);
		m_pSerialCommTestDlg->m_buttonRun2.EnableWindow(TRUE);
		m_pSerialCommTestDlg->m_buttonRun3.EnableWindow(TRUE);
		m_pSerialCommTestDlg->m_buttonRun4.EnableWindow(TRUE);
		m_pSerialCommTestDlg->m_buttonRun5.EnableWindow(TRUE);
		m_pSerialCommTestDlg->m_buttonRun6.EnableWindow(TRUE);
		m_pSerialCommTestDlg->m_buttonRun7.EnableWindow(TRUE);
		m_pSerialCommTestDlg->m_buttonRun8.EnableWindow(TRUE);

		m_pSerialCommTestDlg->m_buttonStop1.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonStop2.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonStop3.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonStop4.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonStop5.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonStop6.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonStop7.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonStop8.EnableWindow(FALSE);

		m_pSerialCommTestDlg->m_buttonTransfer1.EnableWindow(TRUE);
		m_pSerialCommTestDlg->m_buttonTransfer2.EnableWindow(TRUE);
		m_pSerialCommTestDlg->m_buttonTransfer3.EnableWindow(TRUE);
		m_pSerialCommTestDlg->m_buttonTransfer4.EnableWindow(TRUE);
		m_pSerialCommTestDlg->m_buttonTransfer5.EnableWindow(TRUE);
		m_pSerialCommTestDlg->m_buttonTransfer6.EnableWindow(TRUE);
		m_pSerialCommTestDlg->m_buttonTransfer7.EnableWindow(TRUE);
		m_pSerialCommTestDlg->m_buttonTransfer8.EnableWindow(TRUE);

	}
}

void CTest::On_TestStop()
{
	//this function disables the STOP,RUN and TRANSFER buttonS of all the 
	//ports of the serialcommtest dialog 

	if(m_pSerialCommTestDlg != NULL)
	{
		m_pSerialCommTestDlg->m_buttonRun1.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonRun2.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonRun3.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonRun4.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonRun5.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonRun6.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonRun7.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonRun8.EnableWindow(FALSE);

		m_pSerialCommTestDlg->m_buttonStop1.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonStop2.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonStop3.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonStop4.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonStop5.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonStop6.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonStop7.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonStop8.EnableWindow(FALSE);

		m_pSerialCommTestDlg->m_buttonTransfer1.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonTransfer2.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonTransfer3.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonTransfer4.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonTransfer5.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonTransfer6.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonTransfer7.EnableWindow(FALSE);
		m_pSerialCommTestDlg->m_buttonTransfer8.EnableWindow(FALSE);
	}
}
