////////////////////////////////////////
//(c) 1999, 2000 EXAR Corporation 
//All Rights Reserved.
//
//Exar Corporation ("Exar") hereby grants the User of this Exar 
//product-specific XR17C158 Windows NT Device Driver (hereinafter 
//referred to as "Driver") a non-exclusive, nontransferable license 
//to use the Driver in accordance with the term set forth below.  
//Before using the Driver, the User should read the following use 
//restrictions.  If the User does not accept these terms, the Driver 
//should not be used or downloaded.
//The User is granted this limited license to use this Driver for 
//User's end product that includes the Exar XR17C158 Octal UART device, 
//and is not granted rights to sell, loan, rent, lease or license the 
//Driver, in whole or in part, or in modified form to anyone other 
//than User.  User may modify the Driver to suit its specific 
//applications but rights to derivative works and such modifications 
//shall belong to Exar.
//
//The Driver is provided on an "AS IS" basis and Exar makes absolutely 
//no warranty with respect to performance or the information contained 
//therein.  EXAR DISCLAIMS AND USER WAIVES ALL WARRANTIES, EXPRESS OR 
//IMPLIED, INCLUDING WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A 
//PARTICULAR PURPOSE.  The entire risk as to Driver quality and 
//performance is with the User.  ACCORDINGLY, IN NO EVENT SHALL EXAR 
//BE LIABLE FOR ANY DAMAGES, WHETHER IN CONTRACT OR TORT, INCLUDING 
//ANY LOST PROFITS OR OTHER INCIDENTAL, CONSEQUENTIAL, EXEMPLARY, OR 
//PUNITIVE DAMAGES ARISING OUT OF THE USE OR APPLICATION OF THE DRIVER.  
//Further, Exar reserves the right to make changes tot eh Driver without 
//notice to improve reliability, function or design.  Exar does not 
//convey any license under patent rights or any other intellectual 
//property rights, including those of third parties.
//
//Exar is not obligated to provide maintenance or support for the Driver. 
//
//Author:	Kevin Guo
//
///////////////////////////////////////////
#ifndef _HARDWARE_H_
#define _HARDWARE_H_

#define IORW TRUE
#define MMRW FALSE
#define HIGH 0x01
#define LOW	 0x0


typedef	unsigned char KGBYTE;

class CHardWare {
public:
	CHardWare(DWORD dwAddr, HANDLE hDriverHandle);
	CHardWare::~CHardWare(){};
	KGBYTE Read();
	VOID Write( KGBYTE byValue );
	VOID WriteClk( BOOL bValue );
	VOID WriteCs( BOOL bValue );
	VOID WriteDi( BOOL bValue );
	KGBYTE ReadDo();
	DWORD ReOrder( DWORD dwData, KGBYTE byPos );
	VOID KgSleep(DWORD dwCount);
	DWORD ReadE2prom( DWORD dwAddress );
	VOID WriteE2prom( DWORD dwAddrInRom, DWORD dwData );
	VOID WriteEnable( BOOL bTrue );

public:
	DWORD dwMemBase;
	DWORD dwOffset;
	KGBYTE  byOldState;
	HANDLE hDriver;
};


//
// Define the various device type values.  Note that values used by Microsoft
// Corporation are in the range 0-32767, and 32768-65535 are reserved for use
// by customers.
//

#define FILE_DEVICE_XRPORT  0x00008005

//
// Macro definition for defining IOCTL and FSCTL function control codes.  Note
// that function codes 0-2047 are reserved for Microsoft Corporation, and
// 2048-4095 are reserved for customers.
//

#define XRPORT_IOCTL_INDEX  0x805

#define IOCTL_XRPORT_READ_REG2      CTL_CODE(FILE_DEVICE_XRPORT , \
											XRPORT_IOCTL_INDEX + 6,  \
											METHOD_BUFFERED,     \
											FILE_ANY_ACCESS)

#define IOCTL_XRPORT_WRITE_REG2      CTL_CODE(FILE_DEVICE_XRPORT , \
											XRPORT_IOCTL_INDEX + 7,  \
											METHOD_BUFFERED,     \
											FILE_ANY_ACCESS)

#endif //  _HARDWARE_H_