////////////////////////////////////////
//(c) 1999, 2000 EXAR Corporation 
//All Rights Reserved.
//
//Exar Corporation ("Exar") hereby grants the User of this Exar 
//product-specific XR17C158 Windows NT Device Driver (hereinafter 
//referred to as "Driver") a non-exclusive, nontransferable license 
//to use the Driver in accordance with the term set forth below.  
//Before using the Driver, the User should read the following use 
//restrictions.  If the User does not accept these terms, the Driver 
//should not be used or downloaded.
//The User is granted this limited license to use this Driver for 
//User's end product that includes the Exar XR17C158 Octal UART device, 
//and is not granted rights to sell, loan, rent, lease or license the 
//Driver, in whole or in part, or in modified form to anyone other 
//than User.  User may modify the Driver to suit its specific 
//applications but rights to derivative works and such modifications 
//shall belong to Exar.
//
//The Driver is provided on an "AS IS" basis and Exar makes absolutely 
//no warranty with respect to performance or the information contained 
//therein.  EXAR DISCLAIMS AND USER WAIVES ALL WARRANTIES, EXPRESS OR 
//IMPLIED, INCLUDING WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A 
//PARTICULAR PURPOSE.  The entire risk as to Driver quality and 
//performance is with the User.  ACCORDINGLY, IN NO EVENT SHALL EXAR 
//BE LIABLE FOR ANY DAMAGES, WHETHER IN CONTRACT OR TORT, INCLUDING 
//ANY LOST PROFITS OR OTHER INCIDENTAL, CONSEQUENTIAL, EXEMPLARY, OR 
//PUNITIVE DAMAGES ARISING OUT OF THE USE OR APPLICATION OF THE DRIVER.  
//Further, Exar reserves the right to make changes tot eh Driver without 
//notice to improve reliability, function or design.  Exar does not 
//convey any license under patent rights or any other intellectual 
//property rights, including those of third parties.
//
//Exar is not obligated to provide maintenance or support for the Driver. 
//
//Author:	Kevin Guo
//
// RightWrite.cpp : implementation file
//
////////////////////////////////////////////
#include "stdafx.h"
#include "e2prom.h"
#include "myid.h"
#include "RightWrite.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRightWrite dialog

CRightWrite::CRightWrite(CWnd* pParent /*=NULL*/)
	: CDialog(CRightWrite::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRightWrite)
	//}}AFX_DATA_INIT
}

void CRightWrite::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRightWrite)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRightWrite, CDialog)
	//{{AFX_MSG_MAP(CRightWrite)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRightWrite message handlers

void CRightWrite::CreateMore(CE2promDoc * pDoc) 
{
	m_pDoc = pDoc;
	Create(IDD_RIGHTWRITE);
	m_objEditData.Create( WS_CHILD | WS_VISIBLE | WS_BORDER, 
						CRect(70, 10, 135, 30), this, ID_EDIT_RWDATA); 
	m_objEditData.SetWindowText("FFFF");
	m_objEditData.SetLimitText(4);

	ShowWindow(SW_SHOW);
}

void CRightWrite::OnOK() 
{
	// TODO: Add extra validation here
	
	CString strTemp;
	m_objEditData.GetWindowText(strTemp);
	m_pDoc->dwData = String2Dword(strTemp);

	m_pDoc->m_pHw->WriteEnable(TRUE);
	m_pDoc->m_pHw->WriteE2prom(m_pDoc->dwIndex, m_pDoc->dwData);
	m_pDoc->m_pHw->WriteEnable(FALSE);

	Sleep(25); //increased from 12 to 25 to eliminate reading zeroes, Ravi...

	DWORD dwTemp = 0;
	for(int i=0; i<MAX_SIZE; i++)
	{
		dwTemp = m_pDoc->m_pHw->ReadE2prom(i);
		m_pDoc->dwDataRead[i] = dwTemp;
	}

	dwTemp = m_pDoc->m_pHw->ReadE2prom(m_pDoc->dwIndex);
	if(dwTemp == m_pDoc->dwData)
	{
		m_pDoc->dwDataWrite[m_pDoc->dwIndex] = m_pDoc->dwData;
		m_pDoc->dwDataRead[m_pDoc->dwIndex] = m_pDoc->dwData;
	}
	else
	{
		m_pDoc->dwDataWrite[m_pDoc->dwIndex] = m_pDoc->dwData;
		m_pDoc->dwDataRead[m_pDoc->dwIndex] = dwTemp;
	}


/*
	if(bWriteAllow)
	{
		m_pDoc->m_pPCIConfig->MemWriteByte(m_pDoc->dwFullAddr, bData);
	}
	else
	{
		Beep(0x6fff, 0x3000);
		MessageBox( "READ ONLY !!!", "Warning", MB_OK );
	}

	m_pDoc->UpdateAllViews(NULL);

	POSITION pos = m_pDoc->GetFirstViewPosition();
	if(pos != NULL)
	{
		CView* pView = m_pDoc->GetNextView(pos);
		pView->EnableWindow(TRUE);
	}  
*/
	m_pDoc->UpdateAllViews(NULL);
	CDialog::OnOK();
}

DWORD CRightWrite::String2Dword(const CString strTemp)
{
	DWORD dwValue = 0;
	int nLen = strTemp.GetLength();
	for(int i=0; i<nLen; i++)
	{
		char chTemp = strTemp.GetAt(i);
		if(chTemp >= 'A' && chTemp <= 'Z')
		{
			dwValue |= chTemp - 'A' + 10;
		}
		if(chTemp >= 'a' && chTemp <= 'z')
		{
			dwValue |= chTemp - 'a' + 10;
		}
		if(chTemp >= '0' && chTemp <= '9')
		{
			dwValue |= chTemp - '0';
		}
		if(i < nLen - 1)
		{
			dwValue <<= 4;
		}
	}
	return dwValue;
}

void CRightWrite::OnCancel() 
{
	// TODO: Add extra cleanup here
	POSITION pos = m_pDoc->GetFirstViewPosition();
	if(pos != NULL)
	{
		CView* pView = m_pDoc->GetNextView(pos);
		pView->EnableWindow(TRUE);
	}  
	CDialog::OnCancel();
}
