////////////////////////////////////////
//(c) 2003 EXAR Corporation 
//All Rights Reserved.
//
//Exar Corporation ("Exar") hereby grants the User of this Exar 
//product-specific XR17C15x Windows XP Device Driver (hereinafter 
//referred to as "Driver") a non-exclusive, nontransferable license 
//to use the Driver in accordance with the term set forth below.  
//Before using the Driver, the User should read the following use 
//restrictions.  If the User does not accept these terms, the Driver 
//should not be used or downloaded.
//The User is granted this limited license to use this Driver for 
//User's end product that includes the Exar XR17C158 Octal UART PCI 
//device, XR17C154 Quadra UART PCI Device, and XR17C152 Dual UART 
//PCI Device and is not granted rights to sell, loan, rent, lease or 
//license the Driver, in whole or in part, or in modified form to anyone 
//other than User.  User may modify the Driver to suit its specific 
//applications but rights to derivative works and such modifications 
//shall belong to Exar.
//
//The Driver is provided on an "AS IS" basis and Exar makes absolutely 
//no warranty with respect to performance or the information contained 
//therein.  EXAR DISCLAIMS AND USER WAIVES ALL WARRANTIES, EXPRESS OR 
//IMPLIED, INCLUDING WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A 
//PARTICULAR PURPOSE.  The entire risk as to Driver quality and 
//performance is with the User.  ACCORDINGLY, IN NO EVENT SHALL EXAR 
//BE LIABLE FOR ANY DAMAGES, WHETHER IN CONTRACT OR TORT, INCLUDING 
//ANY LOST PROFITS OR OTHER INCIDENTAL, CONSEQUENTIAL, EXEMPLARY, OR 
//PUNITIVE DAMAGES ARISING OUT OF THE USE OR APPLICATION OF THE DRIVER.  
//Further, Exar reserves the right to make changes tot eh Driver without 
//notice to improve reliability, function or design.  Exar does not 
//convey any license under patent rights or any other intellectual 
//property rights, including those of third parties.
//
//Exar is not obligated to provide maintenance or support for the Driver. 
//
//////////////////////////////////////////////////////
/*++

Module Name:

    xrapi.h

Abstract:

    API Interface for Exar's Test GUI Application and Device Driver.
	API Interface for Exar's EEPROM programming App and Device Driver.

Revision History:
	Jan-23 2003, RKR: EEPROM programming utility IOCTL codes defined
	Sep-09 2004: RKR: CFG and UART REG R/W ioctls added for version 2.1.0.0
	Aug-10 2005: RKR: COM3 and CLK24 defined but uncommented to keep COM5 
					  and 14.7MHz as default.

--*/

//


#ifndef _XRAPI_H_
#define _XRAPI_H_



#define EXAR_XONXOFF		0xF0
#define EXAR_RTSCTS			0xF1
#define EXAR_DTRDSR			0xF2
#define EXAR_NOHANDSHAKE	0xF3

typedef struct _COM_PORT_CONFIG {
	unsigned char	Port;
	unsigned char	Dlm;
	unsigned char	Dll;
	unsigned char	WordLen;
	unsigned char	StopBits;
	unsigned char	Parity;
	unsigned char	FlowControl;
	BOOLEAN			FifoEnabled;
} COM_PORT_CONFIG,*PCOM_PORT_CONFIG;

typedef struct _COM_PORT_ENHANCED {
	unsigned char	FlowControl;
	unsigned char	TxFifoTriggerLevel;
	unsigned char	RxFifoTriggerLevel;
	unsigned char	Hysteresis;
	unsigned char	LoopBack;
	unsigned char	RS485;
	unsigned char   IR;
} COM_PORT_ENHANCED,*PCOM_PORT_ENHANCED;

typedef struct _COM_PORT_RW {
	unsigned char	RegAddr;
	unsigned char	OrVal;
	unsigned char	AndVal;
	unsigned char	ReadVal;
	unsigned char	rw;
} COM_PORT_RW,*PCOM_PORT_RW;
//
// Define the various device type values.  Note that values used by Microsoft
// Corporation are in the range 0-32767, and 32768-65535 are reserved for use
// by customers.
//

#define FILE_DEVICE_XRPORT  0x00008005

//
// Macro definition for defining IOCTL and FSCTL function control codes.  Note
// that function codes 0-2047 are reserved for Microsoft Corporation, and
// 2048-4095 are reserved for customers.
//

#define XRPORT_IOCTL_INDEX  0x805


#define IOCTL_XRPORT_SET_CONFIG   CTL_CODE(FILE_DEVICE_XRPORT , \
											XRPORT_IOCTL_INDEX,  \
											METHOD_BUFFERED,     \
											FILE_ANY_ACCESS)

#define IOCTL_XRPORT_GET_CONFIG   CTL_CODE(FILE_DEVICE_XRPORT , \
											XRPORT_IOCTL_INDEX + 1,  \
											METHOD_BUFFERED,     \
											FILE_ANY_ACCESS)

#define IOCTL_XRPORT_SET_ENHANCED   CTL_CODE(FILE_DEVICE_XRPORT , \
											XRPORT_IOCTL_INDEX + 2,  \
											METHOD_BUFFERED,     \
											FILE_ANY_ACCESS)

#define IOCTL_XRPORT_RW				CTL_CODE(FILE_DEVICE_XRPORT , \
											XRPORT_IOCTL_INDEX + 3,  \
											METHOD_BUFFERED,     \
											FILE_ANY_ACCESS)

#define IOCTL_XRPORT_SET_LOOP      CTL_CODE(FILE_DEVICE_XRPORT , \
											XRPORT_IOCTL_INDEX + 4,  \
											METHOD_BUFFERED,     \
											FILE_ANY_ACCESS)

#define IOCTL_XRPORT_SET_RS485      CTL_CODE(FILE_DEVICE_XRPORT , \
											XRPORT_IOCTL_INDEX + 5,  \
											METHOD_BUFFERED,     \
											FILE_ANY_ACCESS)

// RKR: EEPROM programming utility IOCTL codes
#define IOCTL_XRPORT_READ_REG2      CTL_CODE(FILE_DEVICE_XRPORT , \
											XRPORT_IOCTL_INDEX + 6,  \
											METHOD_BUFFERED,     \
											FILE_ANY_ACCESS)

#define IOCTL_XRPORT_WRITE_REG2      CTL_CODE(FILE_DEVICE_XRPORT , \
											XRPORT_IOCTL_INDEX + 7,  \
											METHOD_BUFFERED,     \
											FILE_ANY_ACCESS)

// RKR: CFG and UART R/W IOCTL codes
#define IOCTL_XRPORT_READ_CONFIG_REG	CTL_CODE(FILE_DEVICE_XRPORT , \
											XRPORT_IOCTL_INDEX + 8,  \
											METHOD_BUFFERED,     \
											FILE_ANY_ACCESS)

#define IOCTL_XRPORT_WRITE_CONFIG_REG	CTL_CODE(FILE_DEVICE_XRPORT , \
											XRPORT_IOCTL_INDEX + 9,  \
											METHOD_BUFFERED,     \
											FILE_ANY_ACCESS)


#define IOCTL_XRPORT_READ_UART_REG	CTL_CODE(FILE_DEVICE_XRPORT , \
											XRPORT_IOCTL_INDEX + 10,  \
											METHOD_BUFFERED,     \
											FILE_ANY_ACCESS)

#define IOCTL_XRPORT_WRITE_UART_REG	CTL_CODE(FILE_DEVICE_XRPORT , \
											XRPORT_IOCTL_INDEX + 11,  \
											METHOD_BUFFERED,     \
											FILE_ANY_ACCESS)

typedef struct
{
    unsigned char	bReg;
	unsigned char	bData;

} CONFIG_WRITE, *PCONFIG_WRITE;


#define REG_KEY_XRPORT1_SETTINGS			TEXT("Software\\Exar\\Xr158\\Settings\\Port1")
#define REG_KEY_XRPORT2_SETTINGS			TEXT("Software\\Exar\\Xr158\\Settings\\Port2")
#define REG_KEY_XRPORT3_SETTINGS			TEXT("Software\\Exar\\Xr158\\Settings\\Port3")
#define REG_KEY_XRPORT4_SETTINGS			TEXT("Software\\Exar\\Xr158\\Settings\\Port4")
#define REG_KEY_XRPORT5_SETTINGS			TEXT("Software\\Exar\\Xr158\\Settings\\Port5")
#define REG_KEY_XRPORT6_SETTINGS			TEXT("Software\\Exar\\Xr158\\Settings\\Port6")
#define REG_KEY_XRPORT7_SETTINGS			TEXT("Software\\Exar\\Xr158\\Settings\\Port7")
#define REG_KEY_XRPORT8_SETTINGS			TEXT("Software\\Exar\\Xr158\\Settings\\Port8")

#define THIRTYTWO_TX

// define NEXT_AVAILABLE_COM_PORT_NUMBER to have a dynamic, next available COM port number instead of COM3 or COM5. This define overrules define COM3
// this is defined by default
//#define NEXT_AVAILABLE_COM_PORT_NUMBER

// define COM3 (just uncomment) if you need to start the COM port from 3. Default is 5 - this define will have no effect if NEXT_AVAILABLE_COM_PORT_NUMBER is defined
//#define COM3 

// define CLK24 (just uncomment) if the clock rate is 24 MHz. Default is 14.7 MHz
//#define CLK24

#define VENDOR_ID		(0x13a8)

#define DEVICE_ID_158	(0x0158)
#define DEVICE_ID_258	(0x0258)
#define DEVICE_ID_154	(0x0154)
#define DEVICE_ID_254	(0x0254)
#define DEVICE_ID_152	(0x0152)
#define DEVICE_ID_252	(0x0252)

#endif  //_XRAPI_H_
